/*
 * generated by Xtext 2.12.0
 */
package com.javadude.simpleobjectdsl.generator

import org.eclipse.emf.ecore.resource.Resource
import org.eclipse.xtext.generator.AbstractGenerator
import org.eclipse.xtext.generator.IFileSystemAccess2
import org.eclipse.xtext.generator.IGeneratorContext
import com.javadude.simpleobjectdsl.simpleObjectDsl.Model
import com.javadude.simpleobjectdsl.simpleObjectDsl.ClassType
import com.javadude.simpleobjectdsl.simpleObjectDsl.ListField
import com.javadude.simpleobjectdsl.simpleObjectDsl.BasicField
import com.javadude.simpleobjectdsl.simpleObjectDsl.EnumType
import org.eclipse.emf.ecore.EObject
import com.javadude.simpleobjectdsl.simpleObjectDsl.PrimitiveField

/**
 * Generates code from your model files on save.
 * 
 * See https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#code-generation
 */
class SimpleObjectDslGenerator extends AbstractGenerator {

	IFileSystemAccess2 fsa
	
	override void doGenerate(Resource resource, IFileSystemAccess2 fsa, IGeneratorContext context) {
		this.fsa=fsa
		resource.allContents.filter(Model).forEach[classes.forEach[genClass]]
		resource.allContents.filter(Model).forEach[enums.forEach[genEnum]]
	}
	
	def modelOf(EObject object) {object.eContainer as Model}
	def path(Model model) {model.pkg.replace('.', '/')}
	
	def genClass(ClassType classType) {
		fsa.generateFile('''classType.modelOf.path/classType.name.java''', '''
			package classType.modelOf.pkg;
			
			public class classType.name {
				FOR field : classType.fields
					field.genField
				ENDFOR
			}
		''')
	}
	
	def dispatch String genField(BasicField field) '''
		private field.type.name field.name;
		public field.type.name getfield.name.toFirstUpper() {
			return this.field.name;
		}
		public (field.eContainer as ClassType).name setfield.name.toFirstUpper(field.type.name field.name) {
			this.field.name = field.name;
			return this;
		}
	'''
	
	def getOrIs(String type) {
		if (type == 'boolean')
			'is'
		else
			'get'
	}
	
	def dispatch String genField(PrimitiveField field) '''
		private field.type field.name;
		public field.type field.type.getOrIsfield.name.toFirstUpper() {
			return this.field.name;
		}
		public (field.eContainer as ClassType).name setfield.name.toFirstUpper(field.type field.name) {
			this.field.name = field.name;
			return this;
		}
	'''
	
	def dispatch String genField(ListField field) '''
		private final java.util.List<field.type.name> field.name = new java.util.ArrayList<>();
		private final java.util.List<field.type.name> unmodifiablefield.name.toFirstUpper = java.util.Collections.unmodifiableList(field.name);
		public java.util.List<field.type.name> getfield.name.toFirstUpper() {
			return unmodifiablefield.name.toFirstUpper;
		}
		public (field.eContainer as ClassType).name addfield.singular.toFirstUpper(field.type.name item) {
			this.field.name.add(item);
			return this;
		}
		public (field.eContainer as ClassType).name removefield.singular.toFirstUpper(field.type.name item) {
			this.field.name.remove(item);
			return this;
		}
	'''

	def genEnum(EnumType enumType) {
		fsa.generateFile('''enumType.modelOf.path/enumType.name.java''', '''
			package enumType.modelOf.pkg;
			
			public enum enumType.name {
				FOR value : enumType.values SEPARATOR ',' AFTER ';'
					value.name(value.displayName)
				ENDFOR
				private String displayName;
				private enumType.name(String displayName) {
					this.displayName = displayName;
				}
				public String getDisplayName() {
					return this.displayName;
				}
			}
		''')
	}
}
